﻿using Microsoft.Xna.Framework;

namespace Dam.Controllers
{
    public class CameraController
    {
        public Vector3 InitialPosition;
        public float Zoom;

        public Vector3 Position;
        public Vector3 CurrentPosition;
        private float CurrentZoom;

        public bool isZoomed;

        public Matrix Transform;
        public Matrix InverseTransform;

        public CameraController()
        {
            // 10f = full screen
            Zoom = 1f;
            CurrentZoom = 1f;

            InitialPosition = new Vector3(0, 0, 0);
            Position = InitialPosition;

            CurrentPosition = Vector3.Zero;
        }

        public void MoveToInstant(Vector2 pos)
        {
            MoveToInstant(new Vector3(pos, 0));
        }

        public void MoveToInstant(Vector3 pos)
        {
            Position = pos;
            CurrentPosition = pos;
        }

        public void MoveTo(Vector2 pos)
        {
            MoveTo(new Vector3(pos, 0));
        }

        public void MoveTo(Vector3 pos)
        {
            Position = pos;
        }

        public void Update(GameTime time)
        {
            var amount = (float)time.ElapsedGameTime.TotalSeconds * 5f;

            CurrentPosition = Vector3.Lerp(CurrentPosition, Position, amount);
            CurrentZoom = MathHelper.Lerp(CurrentZoom, Zoom, amount);
            
            Transform =
                Matrix.CreateTranslation(-CurrentPosition.X, -CurrentPosition.Y, 0) *
                Matrix.CreateScale(new Vector3(CurrentZoom, CurrentZoom, 1)) *
                Matrix.CreateTranslation(0, 0, 0);

            InverseTransform = Matrix.Invert(Transform);
        }
    }
}
