﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
using Spl.Core.Input;
using System;

namespace Dam.Controllers
{
    public class DamInputController : InputController
    {
        public static Control MenuMoveUp = new Control(Keys.W, Keys.Up).WithKeys(MouseButtons.ScrollUp);
        public static Control MenuMoveDown = new Control(Keys.S, Keys.Down).WithKeys(MouseButtons.ScrollDown);

        public static Control Jump = new Control(Keys.Z, Keys.W, Keys.Up, Keys.Space).WithKeys(Buttons.A);
        public static Control ThrowBandaid = new Control(Keys.E, Keys.X).WithKeys(Buttons.B, Buttons.X);
        public static Control MoveLeft = new Control(Keys.A, Keys.Left).WithKeys(Buttons.LeftThumbstickLeft, Buttons.RightThumbstickLeft, Buttons.DPadLeft);
        public static Control MoveRight = new Control(Keys.D, Keys.Right).WithKeys(Buttons.LeftThumbstickRight, Buttons.RightThumbstickRight, Buttons.DPadRight);
        
        public static Control Confirm = new Control(Keys.Space, Keys.Enter).WithKeys(Buttons.A);
        public static Control Cancel = new Control(Keys.Escape).WithKeys(Buttons.Back, Buttons.Start);

#if DEBUG_MODE
        public static Control CameraMoveUp = new Control(Keys.I);
        public static Control CameraMoveDown = new Control(Keys.K);
        public static Control CameraMoveLeft = new Control(Keys.J);
        public static Control CameraMoveRight = new Control(Keys.L);

        public static Control SpawnCrack = new Control(Keys.C);
        public static Control ToggleCameraMode = new Control(Keys.V);
        public static Control ShuffleRenderTargets = new Control(Keys.R);
#endif

        public override Control[] MappingOrder => throw new NotImplementedException();

        public override Point CurrentMousePosition
        {
            get
            {
                return Point.Zero;
            }
        }
    }
}
