﻿using Microsoft.Xna.Framework;
using System;

namespace Dam
{
    public class Crack
    {
        public const int HEIGHT = 172;
        public const int GRAPHIC_Y_OFFSET = -HEIGHT / 2;

        public static TimeSpan FirstCrackUntil =  TimeSpan.FromSeconds(5f);
        public static TimeSpan SecondCrackUntil = TimeSpan.FromSeconds(8f);
        public static TimeSpan ThirdCrackUntil =  TimeSpan.FromSeconds(11f);
        public static TimeSpan FourthCrackUntil = TimeSpan.FromSeconds(15f);

        public int SegmentIdx { get; set; }

        // X is just for graphical purposes. Not used for hit testing.
        public int X { get; set; }

        public int Y => WallSegment.GetSegmentY(SegmentIdx);

        public TimeSpan TimeAlive { get; set; }

        public int WaterSpawnCounter { get; set; }

        public bool IsCovered { get; set; }

        public bool IsFlooded => IsActive && TimeAlive > FourthCrackUntil;

        public bool IsActive { get; set; }

        public void Reset(int x)
        {
            X = x;
            TimeAlive = TimeSpan.Zero;
            IsActive = true;

            WaterSpawnCounter = 0;
            IsCovered = false;
        }

        public void Update(GameTime gameTime)
        {
            if (!IsCovered)
            {
                TimeAlive += gameTime.ElapsedGameTime;
                WaterSpawnCounter++;
            }
        }
    }
}
